/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 6.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */

import R from"lodash.isplainobject";import{arrayiffy as p}from"arrayiffy-if-string";import{matchLeftIncl as y,matchRightIncl as h}from"string-match-left-right";import{Ranges as S}from"ranges-push";import{rApply as w}from"ranges-apply";import{trimSpaces as b}from"string-trim-spaces-only";var k="6.0.10";var L=k,A={heads:["{{"],tails:["}}"]};function P(n,$){let T=Object.prototype.hasOwnProperty;if(n===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof n!="string")return n;if($&&!R($))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof $}!`);let r={...$};if(r&&T.call(r,"heads"))if(p(r.heads).every(e=>typeof e=="string"||Array.isArray(e)))typeof r.heads=="string"&&(r.heads=p(r.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The opts.heads contains elements which are not string-type!");if(r&&T.call(r,"tails"))if(p(r.tails).every(e=>typeof e=="string"||Array.isArray(e)))typeof r.tails=="string"&&(r.tails=p(r.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The opts.tails contains elements which are not string-type!");let E=b(n).res;if(E.length===0)return n;n=E;let i={...A,...r};i.heads=i.heads.map(e=>e.trim()),i.tails=i.tails.map(e=>e.trim());let f=!1,D=!1,g=new S({limitToBeAddedWhitespace:!0}),l=new S({limitToBeAddedWhitespace:!0}),a=!0,u=!0,d="";function O(e,c){let t;return h(e,0,c.heads,{trimBeforeMatching:!0,cb:(o,m,s)=>(t=s,!0)})&&h(e,t,c.tails,{trimBeforeMatching:!0,cb:(o,m,s)=>(t=s,!0)})?e.slice(t):e}for(;n!==O(n,i);)n=b(O(n,i)).res;function N(e,c){let t;return!y(e,e.length-1,c.tails,{trimBeforeMatching:!0,cb:(o,m,s)=>(t=s,!0)})||!t?e:y(e,t,c.heads,{trimBeforeMatching:!0,cb:(o,m,s)=>(t=s,!0)})?e.slice(0,t+1):e}for(;n!==N(n,i);)n=b(N(n,i)).res;if(!i.heads.length||!h(n,0,i.heads,{trimBeforeMatching:!0})||!i.tails.length||!y(n,n.length-1,i.tails,{trimBeforeMatching:!0}))return b(n).res;for(let e=0,c=n.length;e<c;e++)if(n[e].trim()!==""){let t;if(h(n,e,i.heads,{trimBeforeMatching:!0,cb:(o,m,s)=>(t=s,!0)})&&t){u=!0,a&&(a=!0);let o;h(n,t,i.tails,{trimBeforeMatching:!0,cb:(s,J,I)=>(o=I,!0)})&&g.push(e,o),l.current()&&f&&d!=="tails"&&g.push(l.current()),f||l.current()&&(g.push(l.current()),l.wipe()),l.push(e,t),d="heads",e=t-1;continue}if(h(n,e,i.tails,{trimBeforeMatching:!0,cb:(o,m,s)=>(t=Number.isInteger(s)?s:n.length,!0)})&&t){u=!0,a?(d==="heads"&&l.wipe(),a=!1):l.push(e,t),d="tails",e=t-1;continue}a&&(a=!0),u&&!f?(f=!0,u=!1):u&&!D?(D=!0,a=!0,u=!1,d==="heads"&&l.wipe()):u&&D&&l.wipe()}return l.current()&&g.push(l.current()),g.current()?w(n,g.current()).trim():n.trim()}export{A as defaults,P as remDup,L as version};
